﻿using Syncfusion.GridCommon.ScrollAxis;
using Syncfusion.ListView.XForms;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;

namespace GettingStarted
{
    public partial class MainPage : ContentPage
    {
        #region Fields

        VisualContainer visualContainer;
        ScrollAxisBase scrollRows;
        bool isLastReached = true;

        #endregion

        #region Constructor

        public MainPage()
        {
            InitializeComponent();
            visualContainer = listView.GetType().GetRuntimeProperties().First(p => p.Name == "VisualContainer").GetValue(listView) as VisualContainer;
            scrollRows = visualContainer.GetType().GetRuntimeProperties().First(p => p.Name == "ScrollRows").GetValue(visualContainer) as ScrollAxisBase;
            scrollRows.Changed += ScrollRows_Changed;
        }

        #endregion

        #region CallBacks

        private void ScrollRows_Changed(object sender, ScrollChangedEventArgs e)
        {
            var lastIndex = scrollRows.LastBodyVisibleLineIndex;
            var header = (listView.HeaderTemplate != null && !listView.IsStickyHeader) ? 1 : 0;
            var footer = (listView.FooterTemplate != null && !listView.IsStickyFooter) ? 1 : 0;
            var totalItems = listView.DataSource.DisplayItems.Count + header + footer;
            if ((lastIndex == totalItems - 1))
            {
                if (isLastReached == true)
                {
                    (listView.LayoutManager as LinearLayout).ScrollToRowIndex(0);
                    isLastReached = false;
                }
                else
                    return;
            }
            else
                isLastReached = true;
        }

        #endregion
    }
}
